//
//  SMBuffer.h
//  Taken from FSStream
//
//  Created by Julien-Pierre Avrous on 22/08/06.
//  Copyright 2006 SourceMac.com. All rights reserved.
//
//

#include <pthread.h>

struct keyedBuffer {
	void *data;
	unsigned int dataLen;
	struct keyedBuffer *next, *prev;
};
typedef struct keyedBuffer keyedBuffer;


class SMBuffer {
public :
	SMBuffer();
	~SMBuffer();
	
	void addBuffer(const void *data, unsigned int len);
	void addBufferNoCopy(const void *data, unsigned int len);
	void getBuffer(void **data, unsigned int *len);
	unsigned int copyContinuousRead(void *outBuffer, unsigned int len);
	unsigned int pickUpContinuousRead(void *outBuffer, unsigned int len);
	bool thereIsData();
	unsigned int bufferSize();
	unsigned int bufferFrameCount();
	void clean();

private:
	void _addBuffer(const void *data, unsigned int len);
	void _getBuffer(void **data, unsigned int *len);
	
	keyedBuffer *first, *last;
	long int tsize;
	unsigned int tcount;
	
	/* for copy full read */
	void *lastData;
	unsigned int lastSize;
	unsigned int lastPosition;
	
	pthread_mutex_t mutex;
};